#ifndef _GLOBALS_H
#define _GLOBALS_H

#define n_file_chars 128

#define PI    3.14159265359
#define PI_d2 1.57079632679
#define ME_1 9.10938291
#define ME_2 -31
#define HBAR_1 1.05457173
#define HBAR_2 -34
#define EC_1 1.6022
#define EC_2 -19
#define KB_1 1.3806488
#define KB_2 -23

#include "structures.h"

double HBAR;
double EC;
double KB;
double NM;
double PS;
double ME;
double VC;

char * float_code;
char * int_code;

double _2M_invH2;
double H2_inv2M;
double H_inv2M;
double KB_TC;
double bandgap_d2;

double GAMMA_0;
double invGAMMA_0;
double WEIGHT;
double DE_CONST;
double LENGTH;


Simulation_control simulation;
Electrons electrons;
Phonons phonons;
Tables tables;
Output_struct outputs;

#endif 
