#ifndef _STRUCTURES_H
#define _STRUCTURES_H

typedef struct{

	double energy;
	double momentum;
	double position;

} Particle;

typedef struct{

	double dx;
	int nx;
	int n_gen_bins;
	
	int gen_mode;
	double generation_fraction;

	double de;
	int ne;

	double dt;
	int nt;
	int out_freq;
	
	int np;
	int init_np;

	int n_interactions;
	int n_interactions_x2;

} Simulation_control;



typedef struct{

	Particle * ensemble;
	int * unused_particle;
	double * n_e_below_e;
	double * temperature;
	double * dos;
	double me;
	double bandgap;

} Electrons;

typedef struct{

	double ** T_pO;
	double ** fp;
	double * E_p;
	double * Mpo;

} Phonons;

typedef struct{

	double ** scattering;
	double ** generation;
	
} Tables;

#endif

typedef struct{

	double ** heat_abs;
	double ** heat_gen;

	int * current;
	int * cumulative_current;
	int * n_generated;

} Output_struct;

