#include <math.h>
#include <time.h>
#include <stdlib.h>
#include "globals.h"
#include "boundaries.h"
#include "double_math.h"
#include "dispersion.h"

void x0_boundary(int particle){
	electrons.ensemble[particle].momentum=-electrons.ensemble[particle].momentum;
	electrons.ensemble[particle].position=-electrons.ensemble[particle].position;
	return;
}

void xlength_boundary(int particle){
	electrons.unused_particle[particle]=1;
	return;
}

void xlength_ohmic_old(int n_expected){
	int i_en;
	int particle;
	double en;
	double rand_en;
	double rand_pol;
	double rand_azi;

	if (n_expected > 0){
		for (particle = 0; particle < simulation.np; particle++){
			if (n_expected){
				if (electrons.unused_particle[particle]){
					n_expected--;
				
					rand_pol = random_number()*PI_d2;//ALL INJECTED INTO DEVICE
					rand_azi = random_number()*PI_d2;
					rand_en = random_number();
					
					en = 0.0;
					for (i_en = 1; i_en < simulation.ne; i_en++){
						en += simulation.de;
						if (rand_en*electrons.n_e_below_e[simulation.ne - 1] < electrons.n_e_below_e[i_en]){
							en -= random_number()*simulation.de;
							break;
						}
					}

					electrons.ensemble[particle].energy = en;
					electrons.ensemble[particle].momentum = -energy_to_momentum(en)*cos(rand_pol)*cos(rand_azi);//-sqrt(-_2M_invH2*KB_TC*log(rand_pz));
					electrons.ensemble[particle].position = LENGTH - simulation.dx*0.0001;

					electrons.unused_particle[particle] = 0;
				}
			}
			else{
				break;
			}
		}
	}

	return;
}

void xlength_ohmic(int n_expected){
	int particle;
	double rand_px;
	double rand_pzy[2];

	if (n_expected > 0){
		for (particle = 0; particle < simulation.np; particle++){
			if (n_expected){
				if (electrons.unused_particle[particle]){
					n_expected--;
					while (1){
						rand_px = random_number();
						gaussian_random(rand_pzy);
						electrons.ensemble[particle].momentum = -sqrt(-_2M_invH2*KB_TC*log(rand_px)*0.5);
						electrons.ensemble[particle].position = LENGTH - simulation.dx*0.001;
						electrons.ensemble[particle].energy = H2_inv2M*(pow(electrons.ensemble[particle].momentum, 2)) + KB_TC*pow(rand_pzy[0], 2);
						if (electrons.ensemble[particle].energy < simulation.de*simulation.ne){ break; }
					}
					electrons.unused_particle[particle] = 0;
				}
			}
			else{
				break;
			}
		}
	}

	return;
}