#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include "globals.h"
#include "carrier_statistics.h"

void number_of_e(int * number){
	int i_x;
	int particle;
	int position;
	for(i_x=0;i_x<simulation.nx;i_x++){
		number[i_x]=0;
	}
	
	for(particle=0;particle<simulation.np;particle++){
		if(!electrons.unused_particle[particle]){
			position=(int)(electrons.ensemble[particle].position/simulation.dx);	
			if(position<simulation.nx && position>=0){
				number[position]++;
			}
		}
	}

	return;
}

void number_of_e_below_e(int ** number){
	int i_x;
	int particle;
	int i_int;
	int position;

	for (i_int = 0; i_int < simulation.n_interactions; i_int++){
		for (i_x = 0; i_x < simulation.nx; i_x++){
			number[i_int][i_x] = 0;
		}
	}

	for (i_int = 0; i_int < simulation.n_interactions; i_int++){
		for (particle = 0; particle < simulation.np; particle++){

			if (!electrons.unused_particle[particle] && electrons.ensemble[particle].energy < phonons.E_p[i_int] - bandgap_d2){
				position = (int)(electrons.ensemble[particle].momentum / simulation.dx);
				if (position < simulation.nx && position >= 0){
					number[i_int][position]++;
				}
			}
		}
	}

	for (i_int = 0; i_int < simulation.n_interactions; i_int++){
		for (i_x = 0; i_x < simulation.nx; i_x++){
			number[i_int][i_x] = pow((double)number[i_int][i_x], 2);
		}
	}

	return;
}


void e_of_e(double * en){
	int i_x;
	int particle;
	int position;
	for(i_x=0;i_x<simulation.nx;i_x++){
		en[i_x]=0;
	}
	
	for(particle=0;particle<simulation.np;particle++){
		if(!electrons.unused_particle[particle]){
			position=(int)(electrons.ensemble[particle].momentum/simulation.dx);	
			if(position<simulation.nx && position>=0){
				en[position]+=electrons.ensemble[particle].energy;
			}
		}
	}

	return;
}


