#include <stdlib.h>
#include <math.h>
#include <float.h>
#include "double_math.h"

#define _2_PI 6.28318530718


double d_sign(double x){
	if(x>0.0){ return 1.0;}
	if(x<0.0){ return -1.0;}
	return 0.0; 
}

double interpolation(double val_low, double val_high, double max_change,double change){
	double mid;

	mid=val_low+(val_high-val_low)/max_change*change;

	return mid;
}

double random_number(){
	double X;
	do{
		X = rand() * (1.0 / RAND_MAX);
		
	} while (X <= DBL_MIN || X >= 1 - DBL_MIN);
	
	return X;
}

void gaussian_random(double r[2]){
	double u;
	double v;
	double s;
	double q;

	do{
		u = random_number()*2.0 - 1.0;
		v = random_number()*2.0 - 1.0;
		s = u*u + v*v;
	} while (s >= 1);
	
	q = sqrt((-2.0*log(s)) / s);
	r[0] = u*q;
	r[1] = v*q;

	return;
}
