#include <math.h>
#include <stdio.h>
#include "globals.h"
#include "dispersion.h"
#include "generation.h"
#include "occupancies.h"
#include "carrier_statistics.h"
#include "double_math.h"
#include "memmory.h"

int net_generation(double * n_expected, int t, double  *n_rounded){
	
	int i_int;	int i_x;
	int N_needed;	double n_needed; int * N_e;
	int total_net_gen=0;
	int is_first=1;

	int_1d_dynamic(&N_e, simulation.nx);


	number_of_e(N_e);

	for (i_x = 0; i_x < simulation.nx - 1; i_x++){
		n_needed = 0.0;
		i_int = 0;
		n_needed = n_expected[i_x];
		N_needed = (int)(n_needed + n_rounded[i_x]);
		n_rounded[i_x] += n_needed - N_needed;
		total_net_gen+=N_needed;
		if (N_needed>0){
			gen_place(i_x, i_int, N_needed);
		}
		else if (N_needed){
			rec_place(i_x, i_int, N_needed);	
		}	
		if (t){
			outputs.heat_gen[i_int][t] += is_first*outputs.heat_gen[i_int][t - 1] + (phonons.E_p[i_int] - 2.0*bandgap_d2) * N_needed;
			if (is_first){ is_first = 0; }
		}
		else{
			outputs.heat_gen[i_int][t] += (phonons.E_p[i_int] - 2.0*bandgap_d2) * N_needed;
		}
	}
	

	return total_net_gen;
}

void gen_place(int pos, int interaction, int N_needed){
	int particle;
	int i_e;
	double r_e;
	double r_x;
	double r_pol;
	double r_azi;
	for (particle = 0; particle < simulation.np; particle++){
		if (!N_needed){ break; }
		if (electrons.unused_particle[particle]){
			N_needed--;
			electrons.unused_particle[particle] = 0;

			r_e = random_number();
			r_x = random_number();
			r_pol = random_number()*PI;
			r_azi = random_number()*PI_d2;
			for (i_e = 1; i_e*simulation.de < phonons.E_p[interaction]-bandgap_d2; i_e++){
				if (r_e*tables.generation[interaction][simulation.ne - 1] < tables.generation[interaction][i_e]){
					electrons.ensemble[particle].energy = i_e*simulation.de - random_number()*simulation.de;
					electrons.ensemble[particle].momentum = energy_to_momentum(electrons.ensemble[particle].energy)*cos(r_pol)*cos(r_azi);
					electrons.ensemble[particle].position = (pos + r_x)*simulation.dx;
					
					break;
				}

			}

		}
	}

	return;
}

void rec_place(int i_x, int interaction, int N_needed){
	int particle;

	for (particle = 0; particle < simulation.np; particle++){
		if (!N_needed){ break; }
		if (!electrons.unused_particle[particle] && electrons.ensemble[particle].energy<phonons.E_p[interaction] - bandgap_d2 && (int)(electrons.ensemble[particle].position / simulation.dx) == i_x){

			electrons.unused_particle[particle] = 1;
			N_needed++;
		}
	}
	return;
}