#define WINDOWS //IF WINDOWS SYSTEM -- delete this line if unix operating system

#include <stdio.h>
#include <string.h>
#include <errno.h>
#ifdef WINDOWS
#include <direct.h>
#define GetCurrentDir _getcwd
#else
#include <unistd.h>
#define GetCurrentDir getcwd
#endif

#include "globals.h"
#include "initialize.h"
#include "monteCarlo.h"
#include "output.h"


main(void){

	//get CWD -- program runs from wherever it is executed
	char working_folder[n_file_chars];
	if (!GetCurrentDir(working_folder, sizeof(working_folder)))
	{
		return errno;
	}
	printf("The working directory is %s\n", working_folder);
	strcat(working_folder, "/");

	initialize(working_folder); //initialize system and allocate primary arrays

	output_Ekx(working_folder, "Ekx-initial"); //write initial distributions
	
	output_temperatures(working_folder, "temperatures-initial"); //write initial temperature (note that it does not change throughout the simulation)
	
	monte_carlo(); //Do monte Carlo simulation of BTE for ensemble of electrons

	output(working_folder); //Write final distributions and temperatures, integrated and instant currents
	

	return;
}

