#include <math.h>
#include "globals.h"
#include "occupancies.h"

void electron_occupancy(double * f, double en,double temp){
	fermi_occupancy(f,en,temp);
}

void phonon_occupancy(double * f, double en,double temp){
	boltzmann_occupancy(f,en,temp);
}

void maxwell_occupancy(double * f, double en,double temp){
	*f=exp(-en/KB/temp);
}

void boltzmann_occupancy(double * f, double en,double temp){
	*f=1.0/(exp(en/KB/temp)-1.0);
}

void fermi_occupancy(double * f, double en,double temp){
	*f=1.0/(exp(en/KB/temp)+1.0);
}


