#include <math.h>
#include <stdio.h>
#include "globals.h"
#include "scattering.h"


void calculate_scattering_intra_pO(double ** scattering_rate,int interaction, double Mpo, int e_change, double * density_e_states){
	
	int i;

	for(i=0;i<simulation.ne;i++){
		if(i+e_change<simulation.ne){
			scattering_rate[2*interaction][i] = 2.0*PI/HBAR*Mpo*Mpo*density_e_states[i+e_change];//absorption
		}
		if(i-e_change>0){
			scattering_rate[2*interaction+1][i] = 2.0*PI/HBAR*Mpo*Mpo*density_e_states[i-e_change];//emission
		}
	}

	return;
}

void calculate_scattering_inter_pO(double ** generation_rate,int interaction, double Mpo,
		int e_change,double * density_e_states,int e_bandgap){
	int i; 

	generation_rate[interaction][0] = 0.0;
	for(i=1;i<simulation.ne;i++){
		if(e_change-e_bandgap-i>0){
			generation_rate[interaction][i] = generation_rate[interaction][i - 1]
				+ density_e_states[i] * density_e_states[e_change - e_bandgap - i]
				* simulation.de / VC;
		}
		else{
			generation_rate[interaction][i] = generation_rate[interaction][i - 1];
		}
	}

	return;
}



